from rest_framework.response import Response
from rest_framework import status

SCHEDULER_BASE_URL = "http://localhost:5000"

OK = 0
FAILED = 1
FILE_ALREADY_EXIST = 101
FILE_FAILED_CREATE_DIR = 102
UNKNOWN_CONTENT = 998
UNKNOWN_ERROR = 999

def failed(message="访问失败", data=None, code=400):
    if code == 400:
        mStatus = status.HTTP_400_BAD_REQUEST
    elif code == 401:
        mStatus = status.HTTP_401_UNAUTHORIZED
    elif code == 403:
        mStatus = status.HTTP_403_FORBIDDEN
    else:
        raise ValueError("不支持的HTTP状态")
    return Response({
        'status': 'failed',
        'message': message,
        'data': data,    
    }, status=mStatus)

def success(message="访问成功", data=None, code=200):
    if code == 200:
        mStatus = status.HTTP_200_OK
    elif code == 201:
        mStatus = status.HTTP_201_CREATED
    elif code == 202:
        mStatus = status.HTTP_202_ACCEPTED
    else:
        raise ValueError("不支持的HTTP状态")
    return Response({
        'status': 'success',
        'message': message,
        'data': data,
    }, status=mStatus)